#ifndef LIPM_MODEL_H
#define LIPM_MODEL_H

#include "eigen_common.h"
#include "mpc_model.h"

class lipmModel:public mpcModel{

public:
	lipmModel();

	void forward_dynamics(double t, Vectord &x, Vectord &u, Vectord &x_next);	
	void user_forward_dynamics_derivatives(double t, Vectord &x, Vectord &u, Matrixd &Fx, Matrixd &Fu, Matrixd3D &Fxx, Matrixd3D &Fux, Matrixd3D &Fuu);
	
	double one_step_cost(double t, Vectord &x, Vectord &u);		
	void user_one_step_cost_derivatives(double t, Vectord &x, Vectord &u, Vectord &Lx, Vectord &Lu, Matrixd &Lxx, Matrixd &Lux, Matrixd &Luu);
	double user_final_cost(double t, Vectord &x, Vectord &u, Vectord &Lx, Matrixd &Lxx);

	void user_control_inequality_constraints(double t, Vectord &x, Vectord&u, Vectord&c, Matrixd &C);
};

#endif;