#ifndef MPC_MODEL_H
#define MPC_MODEL_H

#include "eigen_common.h"

class mpcModel{

public:
	
	virtual void forward_dynamics(double t, Vectord &x, Vectord &u, Vectord &x_next)=0;	
	virtual void user_forward_dynamics_derivatives(double t, Vectord &x, Vectord &u, Matrixd &Fx, Matrixd &Fu, Matrixd3D &Fxx, Matrixd3D &Fux, Matrixd3D &Fuu)=0;
	
	virtual double one_step_cost(double t, Vectord &x, Vectord &u)=0;	
	virtual void user_one_step_cost_derivatives(double t, Vectord &x, Vectord &u, Vectord &Lx, Vectord &Lu, Matrixd &Lxx, Matrixd &Lux, Matrixd &Luu)=0;
	virtual double user_final_cost(double t, Vectord &x, Vectord &u, Vectord &Lx, Matrixd &Lxx)=0;

	virtual void user_control_inequality_constraints(double t, Vectord &x, Vectord&u, Vectord&c, Matrixd &C)=0;

	void forward_dynamics_derivatives_finite_diff();
	void one_step_cost_derivatives_finite_diff();
	
	int num_states;
	int num_actions;

	bool is_linear;

	bool is_control_inequality_constrained;

	double TIMESTEP;

};

#endif